package chat;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.net.*;
import java.io.*;

public class CadreChat extends JFrame {
  JPanel contentPane;
  BorderLayout borderLayout1 = new BorderLayout();
  JPanel panneauEnvoi = new JPanel();
  JPanel panneauConnexion = new JPanel();
  JTextField saisie = new JTextField();
  JButton boutonEnvoi = new JButton();
  JTextField nomHte = new JTextField();
  JButton boutonConnecter = new JButton();
  JButton boutonDconnecter = new JButton();
  JScrollPane jScrollPane1 = new JScrollPane();
  JTextArea rsultat = new JTextArea();
	private final int port = 8189;
	private ServerSocket serveur;
	private Socket connexion;
	private BufferedReader entre;
	private PrintWriter sortie;
	private boolean connexionEnCours;
	private String interlocuteur;

	private class Service extends Thread {
		public void run() {
			try {
				serveur = new ServerSocket(port);
				rsultat.append("Service en coute\n");
				connexion = serveur.accept();
				interlocuteur = connexion.getInetAddress().getHostName();
				rsultat.append("Une connexion est tablie avec "+ interlocuteur +'\n');
				boutonConnecter.setEnabled(false);
				boutonEnvoi.setEnabled(true);
				new GestionFlux().start();
				serveur.close();
			}
			catch (IOException e) {	rsultat.append("Service interrompu\n"); }
			serveur = null;
			rsultat.append("Service ferm\n");
		}
	}

	private class GestionFlux extends Thread {
		public void run() {
		  try {
			  entre = new BufferedReader(new InputStreamReader(connexion.getInputStream()));
		    sortie = new PrintWriter(connexion.getOutputStream(), true);
				connexionEnCours = true;
				while (connexionEnCours) {
					String ligne = entre.readLine();
					if (ligne.equals("Dconnexion")) {
						sortie.println("Accus-reception dconnexion");
					  break;
					}
					if (ligne.equals("Accus-reception dconnexion")) break;
					if (ligne != null) rsultat.append('<'+ interlocuteur +"> "+ ligne +'\n');
				}
				connexionEnCours = false;
				Dconnexion();
		  }
		  catch (IOException e) { rsultat.append("Les flux sont intrrompus\n"); }
			rsultat.append("Sortie de la gestion des flux\n");
		}
	}

  /**Construire le cadre*/
  public CadreChat() {
    enableEvents(AWTEvent.WINDOW_EVENT_MASK);
    try {
      jbInit();
    }
    catch(Exception e) {
      e.printStackTrace();
    }
  }
  /**Initialiser le composant*/
  private void jbInit() throws Exception  {
    //setIconImage(Toolkit.getDefaultToolkit().createImage(CadreChat.class.getResource("[Votre icne]")));
    contentPane = (JPanel) this.getContentPane();
    contentPane.setLayout(borderLayout1);
    this.setResizable(false);
    this.setSize(new Dimension(400, 300));
    this.setTitle("Chat");
    panneauEnvoi.setBackground(SystemColor.activeCaption);
    panneauConnexion.setBackground(SystemColor.activeCaption);
    saisie.setText(" zone de saisie");
    saisie.setColumns(26);
    boutonEnvoi.setEnabled(false);
    boutonEnvoi.setText("Envoyer");
    boutonEnvoi.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        boutonEnvoi_actionPerformed(e);
      }
    });
    nomHte.setText(" nom de l\'hte");
    nomHte.setColumns(15);
    boutonConnecter.setText("Connecter");
    boutonConnecter.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        boutonConnecter_actionPerformed(e);
      }
    });
    boutonDconnecter.setText("Dconnecter");
    boutonDconnecter.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        boutonDconnecter_actionPerformed(e);
      }
    });
    rsultat.setLineWrap(true);
    rsultat.setBorder(BorderFactory.createLoweredBevelBorder());
    rsultat.setForeground(Color.orange);
    rsultat.setBackground(new Color(0, 120, 120));
    rsultat.setEditable(false);
    rsultat.setFont(new java.awt.Font("Dialog", 1, 12));
    jScrollPane1.setBorder(null);
    contentPane.add(panneauEnvoi, BorderLayout.NORTH);
    panneauEnvoi.add(saisie, null);
    panneauEnvoi.add(boutonEnvoi, null);
    contentPane.add(panneauConnexion, BorderLayout.SOUTH);
    panneauConnexion.add(nomHte, null);
    panneauConnexion.add(boutonConnecter, null);
    panneauConnexion.add(boutonDconnecter, null);
    contentPane.add(jScrollPane1, BorderLayout.CENTER);
    jScrollPane1.getViewport().add(rsultat, null);
		rsultat.setText("Bienvenue !\n");
		new Service().start();
  }
  /**Remplac, ainsi nous pouvons sortir quand la fentre est ferme*/
  protected void processWindowEvent(WindowEvent e) {
    super.processWindowEvent(e);
    if (e.getID() == WindowEvent.WINDOW_CLOSING) {
      System.exit(0);
    }
  }

  void boutonConnecter_actionPerformed(ActionEvent e) {
		try {
		  rsultat.append("Tentative de connexion  "+ nomHte.getText() + '\n');
			connexion = new Socket(nomHte.getText(), port);
			new GestionFlux().start();
			rsultat.append("Connexion tablie\n");
  		serveur.close();
			interlocuteur = nomHte.getText();
			boutonConnecter.setEnabled(false);
			boutonEnvoi.setEnabled(true);
		}
		catch (IOException erreur) { rsultat.append("Connexion non tablie\n"); }
  }

  void boutonDconnecter_actionPerformed(ActionEvent e) {
		if (connexionEnCours) {
			sortie.println("Dconnexion");
			Dconnexion();
		}
  }

	void Dconnexion() {
		try {
				while (connexionEnCours); // Attente de l'accus reception de la dconnexion
				connexion.close(); connexion = null;
				boutonConnecter.setEnabled(true);
				boutonEnvoi.setEnabled(false);
				rsultat.setText("La connexion avec "+ interlocuteur +" est perdue\n");
				new Service().start();
		}
		catch (IOException e) { rsultat.append("Processus de dconnexion en dfaut\n"); }
	}

  void boutonEnvoi_actionPerformed(ActionEvent e) {
	  if (connexionEnCours) {
			sortie.println(saisie.getText());
			rsultat.append(saisie.getText()+'\n');
	  }
  }
}